/* 
 License
 This program is free software; you can redistribute it and/or modify it 
 under the terms of the GNU General Public License as published by the 
 Free Software Foundation; either version 2 of the License, or (at your 
 option) any later version.
 This program is distributed in the hope that it will be useful, but 
 WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
 Public License for more details.
 
 */

// to use, add a bookmark for:
// javascript:(function(){dveg_script=document.createElement('SCRIPT');dveg_script.type='text/javascript';dveg_script.src='http://dslabs.teague.com/projects/DesignVeggies/js/dveg_bookmarklet.js?x='+(Math.random());document.getElementsByTagName('head')[0].appendChild(dveg_script);})();


if(location.href != "http://dslabs.teague.com/projects/DesignVeggies/index.php"){
	// get the currently selected text
	var t = getSelectionHTML();


	var div = document.createElement("div");
	div.id = "dveg_bookmarklet";
	div.style['border'] = "2px solid #CCC"; 
	div.style['position'] = "fixed"; 
	div.style['_position'] = "absolute"; 
	div.style['top'] = "0px"; 
	div.style['right'] = "0px";
	div.style['zIndex'] = "10000000"; 
	div.style['background'] = "#333";
	div.style['padding'] = "5px";
	div.style['color'] = "#CCC";
	div.style['fontSize'] = "12px";

	div.innerHTML = "<span style='float: right; cursor: pointer;' onmousedown='closeBookmarklet();'>[close]</span><span style='color: #CCC;'>Design Veggies Bookmarlet</span><br/><br/><form>Title:<br/><input type='text' id='dveg_input_title' size='60' value='"+document.title+"' /><br/><br/>Short description of why this site is good for you:<br/><input type='text' id='dveg_input_desc' size='60' value='' /><br/><br/><center><input type='submit' value='Add site to Design Veggies!' onmousedown='dveg_submit();'/></center></form>";

	function dveg_submit(){
		dveg_sendPageRequest();
		alert("Submitted site to Design Veggies -- Thanks! ");
		closeBookmarklet();
	}

	var dveg_xmlhttp;
	function dveg_sendPageRequest(){
		if (window.XMLHttpRequest) { // code for Mozilla, Safari, and Now IE 7
			dveg_xmlhttp = new XMLHttpRequest();
		}
		if (dveg_xmlhttp != null && typeof(dveg_xmlhttp)=='object') {
			dveg_xmlhttp.onreadystatechange=dveg_xmlHTTPReq;
			var url   = escape(location.href);
			var title = escape(document.getElementById('dveg_input_title').value);
			var desc  = escape(document.getElementById('dveg_input_desc').value);
			dveg_xmlhttp.open('GET', "http://dslabs.teague.com/projects/DesignVeggies/addNewWeLikeIt.php?url="+url+"&title="+title+"&desc="+desc, true);
			dveg_xmlhttp.send(null);
		}
	}

	function dveg_xmlHTTPReq(){
		if (dveg_xmlhttp.readyState==4) {
			// STATUS: 200 [valid web file], 0 [valid local file], 404 [page not found]
			if (dveg_xmlhttp.status==200 || dveg_xmlhttp.status == 0) {
				//alert("" + dveg_xmlhttp.responseText);
			}else{
				// Unhappy :(
				alert("Could not load content from httpReqObject!\nStatus: "+dveg_xmlhttp.status);
			}
		}else{
			//alert("Response ready state did not equal 4!");
		}
	}

	document.body.insertBefore(div, document.body.firstChild);

}

function closeBookmarklet(){
	var dveg = document.getElementById('dveg_bookmarklet');
	dveg.parentNode.removeChild(dveg);
}

function getSelectionHTML () {
	var userSelection;
	if (window.getSelection) {
		// W3C Ranges
		userSelection = window.getSelection ();
		// Get the range:
		try{
			if (userSelection.getRangeAt)
				var range = userSelection.getRangeAt (0);
			else {
				var range = document.createRange ();
				range.setStart (userSelection.anchorNode, userSelection.anchorOffset);
				range.setEnd (userSelection.focusNode, userSelection.focusOffset);
			}
		}catch(e){
			return '';
		}
		// And the HTML:
		var clonedSelection = range.cloneContents ();
		var div = document.createElement ('div');
		div.appendChild (clonedSelection);
		return div.innerHTML;
	} else if (document.selection) {
		// Explorer selection, return the HTML
		userSelection = document.selection.createRange();
		return userSelection.htmlText;
	} else {
		return '';
	}
};
